<?
/*
   Author:  Richard Graham
   Licence: The following content is made available under the terms of the Creative Commons Attribution-Share Alike 2.0 Generic licence. Please see COPYING.TXT for more information.
*/

require("helperfuncts.php");

$submit = strcmp($_REQUEST["submit"],"")!=0;
$somedata = strcmp($_REQUEST["tinkering"],"")!=0;

/*
print "somedata = ".strval($somedata)."<br>";
print "submit = ".strval($submit)."<br>";
print "checkPassword() = ".strval(checkPassword())."<br><br><br>";
*/

if (!checkPassword() and !$somedata){
   askForPassword();
}
if ($submit and checkPassword() and $somedata){
   if (addToXML()){
      print "<p>Done. Add another?</p>";
      print "<form method='POST'><input type='hidden' name='password' value='".$_REQUEST["password"]."'<input type='submit' value='OK'></form>";
   }
   else {
      print "<p>Could not add to database. Try again.</p>";
      print "<form method='POST'><input type='hidden' name='password' value='".$_REQUEST["password"]."'<input type='submit' value='OK'></form>";
   }
}
if (checkPassword() and !$somedata){
   getInput();
}

function checkPassword(){
   require ('password.php');
   return (strcmp($_REQUEST['password'],$password)==0);
}

function askForPassword(){
   print "<center><p>Password required</p>";
   print "<form method='post'><input name='password'><br><br><input type='submit' name='submit' value='Continue'></form></center>";
}

function addToXML(){
   
   // verify all text details are ok to be added
   $textDetails = array("title", "url");
   foreach ($textDetails as $detail){
      if (getTextDetail($detail) == false){
         print "Error - Incorrect ".$detail."<br>";
         return false;
      }
   }
   
   // verify all numerical details are ok
   $numericDetails = array("season", "number", "length", "day", "month", "year");
   foreach ($numericDetails as $detail){
      if (getNumericDetail($detail) == false){
         print "Error - Incorrect ".$detail."<br>";
         return false;
      }
   }
   
   // convert date to unix time
   $date = strtotime(strval(getNumericDetail("month"))."/".strval(getNumericDetail("day"))."/".strval(getNumericDetail("year")));
         
   // now open XML and add data
   $xmlfile = "episodes.xml";
   $original = new DOMDocument(); 
   $original->load($xmlfile);
   
   // Get root of original document
   $originalXPath = new DomXPath($original);
   $originalEpisodes = $originalXPath->query("/episodes");
   
   // Check that the episode is not already in there
   $existingCopies = $originalXPath->query("/episodes/episode/details[season=\"".strval(getNumericDetail("season"))."\" and number=\"".strval(getNumericDetail("number"))."\"]");
   
   if ( ($existingCopies->length) > 0) {
      print "ERROR: Season ".strval(getNumericDetail("season"))." episode number ".strval(getNumericDetail("number"))." had already been added to the database. If you want to change the data please modify the XML manually.<br>";
      return false;
   }
   
   // Create the new XML data
   $episode = $original->createElement("episode");
   $originalEpisodes->item(0)->appendChild($episode);
   
   // Enter the various details to the database
   
   $details = $original->createElement("details");
   $episode->appendChild($details);
   
   $fields = array("title", "url", "season", "number", "length");
   foreach ($fields as $field){
      $details -> appendChild( $original->createElement($field,getTextDetail($field)) );     
   }
   $details -> appendChild( $original->createElement("date",strval($date)));
   
   // Enter all the scores
   
   $scores = $original->createElement("scores");
   $episode->appendChild($scores);
   
   $fields = array("tinkering", "freedom", "community", "underdog", "cheapness", "longevity");
   foreach ($fields as $field){
      $scores -> appendChild( $original->createElement($field, strval(getScore($field)) ) );     
   }
   
   $original->save($xmlfile);
   system("tidy -xml -indent -m ".$xmlfile);
   
   return true;
}

function getInput(){

   print "<form method='post' name='newReference'>";
   
   print "Please enter details for the new episode <br><br>";
   
   print "<b>Details</b><br>";
   
   print "<table border='1'>";
   makeInput("Title");
   makeInput("Season");
   makeInput("Number");
   makeInput("Length (minutes)");
   makeInput("URL");
   makeInput("Day");
   makeInput("Month");
   makeInput("Year");
   print "</table><br>";
   
   print "<b>Scores</b><br>";
   
   print "<table border='1'>";
   makeRankInput("Tinkering");
   makeRankInput("Freedom crusading");
   makeRankInput("Community");
   makeRankInput("Underdog");
   makeRankInput("Cheapness");
   makeRankInput("Longevity");
   print "</table><br>";
   
   print "<input type='hidden' name='password' value='".$_REQUEST['password']."'</hidden>";
   print "<br><br><input type='submit' name='submit' value='Submit'>";
   
   print "</form>";
}

?>
