<?
/*
   Author:  Richard Graham
   Licence: The following content is made available under the terms of the Creative Commons Attribution-Share Alike 2.0 Generic licence. Please see COPYING.TXT for more information.
*/


// Returns an array with the field name of the bigest score
// if there is more than one biggest score the array will have an entry for each
function biggestScores(){
   $fields = array("tinkering", "freedom", "community", "underdog", "cheapness");
   $biggest = array();
   $max = 0;
   foreach ($fields as $field){
      if ( getScore($field) == $max) {
         $biggest[] = $field;
         continue;
      }
      if ( getScore($field) > $max ) {
         $max = getScore($field);
         $biggest = array($field);
         continue;
      }
   }
   return $biggest;
}

// Returns an array with the field name of the bigest score
// if there is more than one biggest score the array will have an entry for each
function smallestScores(){
   $fields = array("tinkering", "freedom", "community", "underdog", "cheapness");
   $smallest = array();
   $min = 10;
   foreach ($fields as $field){
      if ( getScore($field) == $min) {
         $smallest[] = $field;
         continue;
      }
      if ( getScore($field) < $min ) {
         $min = getScore($field);
         $smallest = array($field);
         continue;
      }
   }
   return $smallest;
}

function getXMLField($path, $xml){
   $xpath = new DomXPath($xml);
   $node = $xpath->query($path)->item(0);
   return $node->nodeValue;
}

function changeXMLField($path, $newValue, $xml){
   $xpath = new DomXPath($xml);

   $slash = strrpos($path, '/');
   $name = substr($path, $slash+1);
   
   $node = $xpath->query($path)->item(0);
   // make a new node to replace the old one
   $newnode = $xml->createElement($name, strval($newValue));
   $node->parentNode->replaceChild($newnode, $node);
}

function variable($name){
   // gives the variable name to use internally for a given full text name for a property
   $pieces = explode(" ", $name);
   return strtolower($pieces[0]);
}

function makeInput($name){
   print "\n<tr> <td>$name</td> <td> <input name='".variable($name)."'> </td></tr>";
}

function getScore($property){
   $scoreString = $_REQUEST[$property];
   return intval($scoreString);
}
      
function getTextDetail($property){
   // returns false if the detail has not been entered, otherwise returns the detail
   $detail = $_REQUEST[$property];
   $detail = trim($detail);
   if (!strcmp($detail,"") === 0) {
      return false;
   }
   else {
      return $detail;
   }
}

function getNumericDetail($property){
   // returns false if the detail has not been entered, otherwise returns the detail
   $detail = getTextDetail($property);
   if ($detail == false or is_numeric($detail) == false) {
      return false;
   }
   return intval($detail);
}

function makeRankInput($name){
   print "\n<tr> <td>$name &nbsp</td> <td>";
   makeRankBox(variable($name));
   print "</td></tr>";
}

function makeRankBox($name) {
   print "   <select name='".$name."'>
               <option>0 - Don't care at all</option>
               <option>1</option>
               <option>2</option>
               <option>3</option>
               <option>4</option>
               <option selected='selected'>5 - Neutral</option>
               <option>6</option>
               <option>7</option>
               <option>8</option>
               <option>9</option>
               <option>10 - Very much so</option>
              </select>
         ";
}

function getDetailFromXML($episodeXML, $detail){
   $xml = new DOMDocument();
   $xml->loadXML($episodeXML);
   $xpath = new DomXPath($xml);
   $detail = $xpath->query("/episode/details/".$detail)->item(0)->nodeValue;
   return $detail;
}

function getDateFromXML($episodeXML){
   $xml = new DOMDocument();
   $xml->loadXML($episodeXML);
   $xpath = new DomXPath($xml);
   $date = $xpath->query("/episode/details/date")->item(0)->nodeValue;
   return intval($date);
}

// Given an XML fragment <episode>...</episode> with scores inside, return the score for the given trait
function getScoreFromXML($episodeXML, $trait){
   $xml = new DOMDocument();
   $xml->loadXML($episodeXML);
   $xpath = new DomXPath($xml);
   $score = $xpath->query("/episode/scores/$trait")->item(0)->nodeValue;
   return intval($score);
}

?>
