<?
/*
   Author:  Richard Graham
   Licence: The following content is made available under the terms of the Creative Commons Attribution-Share Alike 2.0 Generic licence. Please see COPYING.TXT for more information.
*/
   
   require ('helperfuncts.php');
   
   $fields = array("Freedom Crusading", "Tinkering", "Community", "Underdog", "Cheapness");
   
   $xml = new DOMDocument();
   $xml->load('stats.xml');
   $xpath = new DomXPath($xml);

   $total = intval($xpath->query("/statistics/total")->item(0)->nodeValue);
   
   print "<p>To date, $total visitors have submitted their Lug Radio Top Trumps scores. The number of people who ranked a given category highest and lowest are shown in the table below.</p>";
   
   print "<table border='1'>\n";
   print "\t<tr><td align='center'>&nbsp&nbsp &nbsp&nbsp</td><td align='center'>&nbsp <u>Most Important</u> &nbsp</td><td align='center'>&nbsp <u>Least Important</u> &nbsp</td></tr>\n";
   foreach ($fields as $field){
      print "\t<tr><td align='center'>&nbsp&nbsp $field &nbsp&nbsp</td><td align='center'><font size='+1'>&nbsp ".round(getStat("mostImportant", $field, $xpath))." &nbsp</font></td><td align='center'><font size='+1'>&nbsp ".round(getStat("leastImportant", $field, $xpath))." &nbsp</font></td></tr>\n";
   }
   print "<table>\n";
   
   print "<p>The averages scores are show in the following table.</p>";
  
   print "<table border='1'>\n";
   foreach ($fields as $field){
      print "\t<tr><td align='center'>&nbsp&nbsp $field &nbsp&nbsp</td><td align='center'><font size='+1'>&nbsp ".round(getStat("averages", $field, $xpath))." &nbsp</font></td></tr>\n";
   }
   print "<table>\n";
   
   print "<br><a href='LugRadioTopTrumps.php'>Return to Lug Radio Top Trumps</a>";

   
   function getStat($category, $field, $xpath){
      $field = variable($field);
      return floatval($xpath->query("/statistics/$category/$field")->item(0)->nodeValue);
   }
   
?>
